# OpalLineEndPoint Class Reference

`#include <lidep.h>`

Inheritance diagram for OpalLineEndPoint:

[legend]
Collaboration diagram for OpalLineEndPoint:
[legend]

## Public Member Functions

Construction
| OpalLineEndPoint (OpalManager &manager)
| ~OpalLineEndPoint ()
| Make sure thread has stopped before exiting.
Overrides from OpalEndPoint
virtual PSafePtr< OpalConnection > | MakeConnection (OpalCall &call, const PString &party, void *userData=NULL, unsigned int options=0, OpalConnection::StringOptions *stringOptions=NULL)
virtual OpalMediaFormatList | GetMediaFormats () const
Connection management
virtual OpalLineConnection * | CreateConnection (OpalCall &call, OpalLine &line, void *userData, const PString &number)
LID management
PSafePtr< OpalLineConnection > | GetLIDConnectionWithLock (const PString &token, PSafetyMode mode=PSafeReadWrite)
PBoolean | AddLine (OpalLine *line)
void | RemoveLine (OpalLine *line)
const PList< OpalLine > & | GetLines () const
void | RemoveLine (const PString &token)
void | RemoveAllLines ()
virtual PBoolean | AddLinesFromDevice (OpalLineInterfaceDevice &device)
void | RemoveLinesFromDevice (OpalLineInterfaceDevice &device)
PBoolean | AddDeviceNames (const PStringArray &descriptors)
PBoolean | AddDeviceName (const PString &descriptor)
const OpalLineInterfaceDevice * | GetDeviceByName (const PString &descriptor)
virtual PBoolean | AddDevice (OpalLineInterfaceDevice *device)
void | RemoveDevice (OpalLineInterfaceDevice *device)
void | RemoveDevices ()
OpalLine * | GetLine (const PString &lineName, bool enableAudio=false, bool terminating=true)
void | SetDefaultLine (const PString &lineName)
bool | SetCountryCode (OpalLineInterfaceDevice::T35CountryCodes country)
bool | SetCountryCodeName (const PString &countryName)

## Protected Member Functions

| PDECLARE_NOTIFIER (PThread, OpalLineEndPoint, MonitorLines)
virtual void | MonitorLine (OpalLine &line)

## Protected Attributes

OpalLIDList | devices
OpalLineList | lines
PString | defaultLine
PMutex | linesMutex
PThread * | monitorThread
PSyncPoint | exitFlag

## Detailed Description

This class describes and endpoint that handles LID lines. This is the ancestor class to the LID endpoints that handle PSTN lines and POTS lines respectively.

## Constructor & Destructor Documentation

OpalLineEndPoint::OpalLineEndPoint | ( | OpalManager & | manager | ) |

Create a new endpoint.

Parameters:

  manager | Manager of all endpoints.

OpalLineEndPoint::~OpalLineEndPoint | ( |  | ) |

Make sure thread has stopped before exiting.

## Member Function Documentation

virtual PBoolean OpalLineEndPoint::AddDevice | ( | OpalLineInterfaceDevice * | device | ) | `[virtual]`

Add a line interface device to the endpoint. This will add the OpalLineInterfaceDevice descendent and all of the lines that it has to the endpoint.

The lid is then "owned" by the endpoint and will be deleted automatically when the endpoint is destroyed.

Note the device should already be open or no lines are added.

Returns true if at least one line was added.

Parameters:

  device | Device to add

PBoolean OpalLineEndPoint::AddDeviceName | ( | const PString & | descriptor | ) |

Add a line interface device to the endpoint by name. This will add the registered OpalLineInterfaceDevice descendent and all of the lines that it has to the endpoint. The parameter is a string as would be returned from the OpalLineInterfaceDevice::GetAllDevices() function.

Returns true if at least one line was added or the descriptor was already present.

Parameters:

  descriptor | Device descritption to add

PBoolean OpalLineEndPoint::AddDeviceNames | ( | const PStringArray & | descriptors | ) |

Add a line interface devices to the endpoint by name. This calls AddDeviceName() for each entry in the array.

Returns true if at least one line from one device was added.

Parameters:

  descriptors | Device descritptions to add

PBoolean OpalLineEndPoint::AddLine | ( | OpalLine * | line | ) |

Add a line to the endpoint. Note that once the line is added it is "owned" by the endpoint and should not be deleted directly. Use the RemoveLine() function to delete the line.

Returns true if the lines device was open and the line was added.

virtual PBoolean OpalLineEndPoint::AddLinesFromDevice | ( | OpalLineInterfaceDevice & | device | ) | `[virtual]`

Add all lines on a device to the endpoint. Note that once the line is added it is "owned" by the endpoint and should not be deleted directly. Use the RemoveLine() function to delete the line.

Note the device should already be open or no lines are added.

Returns true if at least one line was added.

Parameters:

  device | Device to add lines

virtual OpalLineConnection* OpalLineEndPoint::CreateConnection | ( | OpalCall & | call,
|  | OpalLine & | line,
|  | void * | userData,
|  | const PString & | number |
| ) |  |  | `[virtual]`

Parameters:

  call | Call that owns the connection
  line | Line connection is to use
  userData | Arbitrary user data from MakeConnection
  number | Number to dial in outgoing call

const OpalLineInterfaceDevice* OpalLineEndPoint::GetDeviceByName | ( | const PString & | descriptor | ) |

Indicate if the line interface device is in use by the endpoint.

Parameters:

  descriptor | Device descritption to add

PSafePtr<OpalLineConnection> OpalLineEndPoint::GetLIDConnectionWithLock | ( | const PString & | token,
|  | PSafetyMode | mode = `PSafeReadWrite` |
| ) |  |  | `[inline]`

Find a connection that uses the specified token. This searches the endpoint for the connection that contains the token as provided by functions such as MakeConnection().

Parameters:

  token | Token to identify connection
  mode | Lock mode

OpalLine* OpalLineEndPoint::GetLine | ( | const PString & | lineName,
|  | bool | enableAudio = `false`,
|  | bool | terminating = `true` |
| ) |  |  |

Get the line by name. The lineName parameter may be "*" to matche the first line.

If the enableAudio flag is true then the EnableAudio() function is called on the line and it is returns only if successful. This effectively locks the line for exclusive use of the caller.

Parameters:

  lineName | Name of line to get.
  enableAudio | Flag to enable audio on the line.
  terminating | Flag to indicate should be a terminating line

const PList<OpalLine>& OpalLineEndPoint::GetLines | ( |  | ) | const`[inline]`

get all lines of the endpopint

Returns:
  the constant list of all lines belonged to the endpoint

virtual OpalMediaFormatList OpalLineEndPoint::GetMediaFormats | ( |  | ) | const`[virtual]`

Get the data formats this endpoint is capable of operating. This provides a list of media data format names that may be used by an OpalMediaStream may be created by a connection from this endpoint.

Note that a specific connection may not actually support all of the media formats returned here, but should return no more.

The default behaviour is pure.

Implements OpalEndPoint.

virtual PSafePtr<OpalConnection> OpalLineEndPoint::MakeConnection | ( | OpalCall & | call,
|  | const PString & | party,
|  | void * | userData = `NULL`,
|  | unsigned int | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  | `[virtual]`

Set up a connection to a remote party. This is called from the OpalManager::MakeConnection() function once it has determined that this is the endpoint for the protocol.

The general form for this party parameter is:

[proto:][alias@][transport$]address[:port]

where the various fields will have meanings specific to the endpoint type. For example, with H.323 it could be "h323:Fred@site.com" which indicates a user Fred at gatekeeper size.com. Whereas for the PSTN endpoint it could be "pstn:5551234" which is to call 5551234 on the first available PSTN line.

The proto field is optional when passed to a specific endpoint. If it is present, however, it must agree with the endpoints protocol name or false is returned.

This function usually returns almost immediately with the connection continuing to occur in a new background thread.

If false is returned then the connection could not be established. For example if a PSTN endpoint is used and the assiciated line is engaged then it may return immediately. Returning a non-NULL value does not mean that the connection will succeed, only that an attempt is being made.

The default behaviour is pure.

Parameters:

  call | Owner of connection
  party | Remote party to call
  userData | Arbitrary data to pass to connection
  options | options to pass to conneciton
  stringOptions | Options to pass to connection

Implements OpalEndPoint.

virtual void OpalLineEndPoint::MonitorLine | ( | OpalLine & | line | ) | `[protected, virtual]`

OpalLineEndPoint::PDECLARE_NOTIFIER | ( | PThread | ,
|  | OpalLineEndPoint | ,
|  | MonitorLines |  |
| ) |  |  | `[protected]`

void OpalLineEndPoint::RemoveAllLines | ( |  | ) |

Remove all lines from the endpoint. The line is removed from the endpoints processing and deleted. All devices are also deleted from the endpoint

void OpalLineEndPoint::RemoveDevice | ( | OpalLineInterfaceDevice * | device | ) |

Remove the device and all its lines from the endpoint. The device will be automatically deleted.

Parameters:

  device | Device to remove

void OpalLineEndPoint::RemoveDevices | ( |  | ) | `[inline]`

Remove all devices from the endpoint.

void OpalLineEndPoint::RemoveLine | ( | const PString & | token | ) |

Remove a line from the endpoint. The line is removed from the endpoints processing and deleted.

void OpalLineEndPoint::RemoveLine | ( | OpalLine * | line | ) |

Remove a line from the endpoint. The line is removed from the endpoints processing and deleted.

void OpalLineEndPoint::RemoveLinesFromDevice | ( | OpalLineInterfaceDevice & | device | ) |

Remove all lines on a device from the endpoint. The lines are removed from the endpoints processing and deleted.

Parameters:

  device | Device to remove lines

bool OpalLineEndPoint::SetCountryCode | ( | OpalLineInterfaceDevice::T35CountryCodes | country | ) |

Set the country code set for the device. This may change the line analogue coefficients, ring detect, call disconnect detect and call progress tones to fit the countries telephone network.

Parameters:

  country | Country code for device

bool OpalLineEndPoint::SetCountryCodeName | ( | const PString & | countryName | ) |

Set the country code set for the device.

Parameters:

  countryName | Country code for device

void OpalLineEndPoint::SetDefaultLine | ( | const PString & | lineName | ) |

Set the default line to be used on call. If the lineName is "*" then the first available line is used.

Parameters:

  lineName | Name of line to set to default.

## Field Documentation

PString OpalLineEndPoint::defaultLine `[protected]`

OpalLIDList OpalLineEndPoint::devices `[protected]`

PSyncPoint OpalLineEndPoint::exitFlag `[protected]`

OpalLineList OpalLineEndPoint::lines `[protected]`

PMutex OpalLineEndPoint::linesMutex `[protected]`

PThread* OpalLineEndPoint::monitorThread `[protected]`

The documentation for this class was generated from the following file:

- lidep.h